Merge branch 'kb/maint-diff-ws-check'
[git/git.git] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
17
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
21 done,*)
22 # do not redirect again
23 ;;
24 *' --tee '*|*' --va'*)
25 mkdir -p test-results
26 BASE=test-results/$(basename "$0" .sh)
27 (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $? > $BASE.exit) | tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
30 exit
31 ;;
32 esac
33
34 # Keep the original TERM for say_color
35 ORIGINAL_TERM=$TERM
36
37 # For repeatability, reset the environment to known value.
38 LANG=C
39 LC_ALL=C
40 PAGER=cat
41 TZ=UTC
42 TERM=dumb
43 export LANG LC_ALL PAGER TERM TZ
44 EDITOR=:
45 unset VISUAL
46 unset GIT_EDITOR
47 unset AUTHOR_DATE
48 unset AUTHOR_EMAIL
49 unset AUTHOR_NAME
50 unset COMMIT_AUTHOR_EMAIL
51 unset COMMIT_AUTHOR_NAME
52 unset EMAIL
53 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
54 unset GIT_AUTHOR_DATE
55 GIT_AUTHOR_EMAIL=author@example.com
56 GIT_AUTHOR_NAME='A U Thor'
57 unset GIT_COMMITTER_DATE
58 GIT_COMMITTER_EMAIL=committer@example.com
59 GIT_COMMITTER_NAME='C O Mitter'
60 unset GIT_DIFF_OPTS
61 unset GIT_DIR
62 unset GIT_WORK_TREE
63 unset GIT_EXTERNAL_DIFF
64 unset GIT_INDEX_FILE
65 unset GIT_OBJECT_DIRECTORY
66 unset GIT_CEILING_DIRECTORIES
67 unset SHA1_FILE_DIRECTORIES
68 unset SHA1_FILE_DIRECTORY
69 unset GIT_NOTES_REF
70 unset GIT_NOTES_DISPLAY_REF
71 unset GIT_NOTES_REWRITE_REF
72 unset GIT_NOTES_REWRITE_MODE
73 GIT_MERGE_VERBOSITY=5
74 export GIT_MERGE_VERBOSITY
75 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
76 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
77 export EDITOR
78
79 # Protect ourselves from common misconfiguration to export
80 # CDPATH into the environment
81 unset CDPATH
82
83 unset GREP_OPTIONS
84
85 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
86 1|2|true)
87 echo "* warning: Some tests will not work if GIT_TRACE" \
88 "is set as to trace on STDERR ! *"
89 echo "* warning: Please set GIT_TRACE to something" \
90 "other than 1, 2 or true ! *"
91 ;;
92 esac
93
94 # Convenience
95 #
96 # A regexp to match 5 and 40 hexdigits
97 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
98 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
99
100 # Each test should start with something like this, after copyright notices:
101 #
102 # test_description='Description of this test...
103 # This test checks if command xyzzy does the right thing...
104 # '
105 # . ./test-lib.sh
106 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
107 TERM=$ORIGINAL_TERM &&
108 export TERM &&
109 [ -t 1 ] &&
110 tput bold >/dev/null 2>&1 &&
111 tput setaf 1 >/dev/null 2>&1 &&
112 tput sgr0 >/dev/null 2>&1
113 ) &&
114 color=t
115
116 while test "$#" -ne 0
117 do
118 case "$1" in
119 -d|--d|--de|--deb|--debu|--debug)
120 debug=t; shift ;;
121 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
122 immediate=t; shift ;;
123 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
124 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
125 -h|--h|--he|--hel|--help)
126 help=t; shift ;;
127 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
128 verbose=t; shift ;;
129 -q|--q|--qu|--qui|--quie|--quiet)
130 # Ignore --quiet under a TAP::Harness. Saying how many tests
131 # passed without the ok/not ok details is always an error.
132 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
133 --with-dashes)
134 with_dashes=t; shift ;;
135 --no-color)
136 color=; shift ;;
137 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
138 valgrind=t; verbose=t; shift ;;
139 --tee)
140 shift ;; # was handled already
141 --root=*)
142 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
143 shift ;;
144 *)
145 echo "error: unknown test option '$1'" >&2; exit 1 ;;
146 esac
147 done
148
149 if test -n "$color"; then
150 say_color () {
151 (
152 TERM=$ORIGINAL_TERM
153 export TERM
154 case "$1" in
155 error) tput bold; tput setaf 1;; # bold red
156 skip) tput bold; tput setaf 2;; # bold green
157 pass) tput setaf 2;; # green
158 info) tput setaf 3;; # brown
159 *) test -n "$quiet" && return;;
160 esac
161 shift
162 printf "%s" "$*"
163 tput sgr0
164 echo
165 )
166 }
167 else
168 say_color() {
169 test -z "$1" && test -n "$quiet" && return
170 shift
171 echo "$*"
172 }
173 fi
174
175 error () {
176 say_color error "error: $*"
177 GIT_EXIT_OK=t
178 exit 1
179 }
180
181 say () {
182 say_color info "$*"
183 }
184
185 test "${test_description}" != "" ||
186 error "Test script did not set test_description."
187
188 if test "$help" = "t"
189 then
190 echo "$test_description"
191 exit 0
192 fi
193
194 exec 5>&1
195 if test "$verbose" = "t"
196 then
197 exec 4>&2 3>&1
198 else
199 exec 4>/dev/null 3>/dev/null
200 fi
201
202 test_failure=0
203 test_count=0
204 test_fixed=0
205 test_broken=0
206 test_success=0
207
208 test_external_has_tap=0
209
210 die () {
211 code=$?
212 if test -n "$GIT_EXIT_OK"
213 then
214 exit $code
215 else
216 echo >&5 "FATAL: Unexpected exit with code $code"
217 exit 1
218 fi
219 }
220
221 GIT_EXIT_OK=
222 trap 'die' EXIT
223
224 # The semantics of the editor variables are that of invoking
225 # sh -c "$EDITOR \"$@\"" files ...
226 #
227 # If our trash directory contains shell metacharacters, they will be
228 # interpreted if we just set $EDITOR directly, so do a little dance with
229 # environment variables to work around this.
230 #
231 # In particular, quoting isn't enough, as the path may contain the same quote
232 # that we're using.
233 test_set_editor () {
234 FAKE_EDITOR="$1"
235 export FAKE_EDITOR
236 EDITOR='"$FAKE_EDITOR"'
237 export EDITOR
238 }
239
240 test_decode_color () {
241 awk '
242 function name(n) {
243 if (n == 0) return "RESET";
244 if (n == 1) return "BOLD";
245 if (n == 30) return "BLACK";
246 if (n == 31) return "RED";
247 if (n == 32) return "GREEN";
248 if (n == 33) return "YELLOW";
249 if (n == 34) return "BLUE";
250 if (n == 35) return "MAGENTA";
251 if (n == 36) return "CYAN";
252 if (n == 37) return "WHITE";
253 if (n == 40) return "BLACK";
254 if (n == 41) return "BRED";
255 if (n == 42) return "BGREEN";
256 if (n == 43) return "BYELLOW";
257 if (n == 44) return "BBLUE";
258 if (n == 45) return "BMAGENTA";
259 if (n == 46) return "BCYAN";
260 if (n == 47) return "BWHITE";
261 }
262 {
263 while (match($0, /\x1b\[[0-9;]*m/) != 0) {
264 printf "%s<", substr($0, 1, RSTART-1);
265 codes = substr($0, RSTART+2, RLENGTH-3);
266 if (length(codes) == 0)
267 printf "%s", name(0)
268 else {
269 n = split(codes, ary, ";");
270 sep = "";
271 for (i = 1; i <= n; i++) {
272 printf "%s%s", sep, name(ary[i]);
273 sep = ";"
274 }
275 }
276 printf ">";
277 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
278 }
279 print
280 }
281 '
282 }
283
284 nul_to_q () {
285 perl -pe 'y/\000/Q/'
286 }
287
288 q_to_nul () {
289 perl -pe 'y/Q/\000/'
290 }
291
292 q_to_cr () {
293 tr Q '\015'
294 }
295
296 q_to_tab () {
297 tr Q '\011'
298 }
299
300 append_cr () {
301 sed -e 's/$/Q/' | tr Q '\015'
302 }
303
304 remove_cr () {
305 tr '\015' Q | sed -e 's/Q$//'
306 }
307
308 test_tick () {
309 if test -z "${test_tick+set}"
310 then
311 test_tick=1112911993
312 else
313 test_tick=$(($test_tick + 60))
314 fi
315 GIT_COMMITTER_DATE="$test_tick -0700"
316 GIT_AUTHOR_DATE="$test_tick -0700"
317 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
318 }
319
320 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
321 #
322 # This will commit a file with the given contents and the given commit
323 # message. It will also add a tag with <message> as name.
324 #
325 # Both <file> and <contents> default to <message>.
326
327 test_commit () {
328 file=${2:-"$1.t"}
329 echo "${3-$1}" > "$file" &&
330 git add "$file" &&
331 test_tick &&
332 git commit -m "$1" &&
333 git tag "$1"
334 }
335
336 # Call test_merge with the arguments "<message> <commit>", where <commit>
337 # can be a tag pointing to the commit-to-merge.
338
339 test_merge () {
340 test_tick &&
341 git merge -m "$1" "$2" &&
342 git tag "$1"
343 }
344
345 # This function helps systems where core.filemode=false is set.
346 # Use it instead of plain 'chmod +x' to set or unset the executable bit
347 # of a file in the working directory and add it to the index.
348
349 test_chmod () {
350 chmod "$@" &&
351 git update-index --add "--chmod=$@"
352 }
353
354 # Use test_set_prereq to tell that a particular prerequisite is available.
355 # The prerequisite can later be checked for in two ways:
356 #
357 # - Explicitly using test_have_prereq.
358 #
359 # - Implicitly by specifying the prerequisite tag in the calls to
360 # test_expect_{success,failure,code}.
361 #
362 # The single parameter is the prerequisite tag (a simple word, in all
363 # capital letters by convention).
364
365 test_set_prereq () {
366 satisfied="$satisfied$1 "
367 }
368 satisfied=" "
369
370 test_have_prereq () {
371 # prerequisites can be concatenated with ','
372 save_IFS=$IFS
373 IFS=,
374 set -- $*
375 IFS=$save_IFS
376
377 total_prereq=0
378 ok_prereq=0
379 missing_prereq=
380
381 for prerequisite
382 do
383 total_prereq=$(($total_prereq + 1))
384 case $satisfied in
385 *" $prerequisite "*)
386 ok_prereq=$(($ok_prereq + 1))
387 ;;
388 *)
389 # Keep a list of missing prerequisites
390 if test -z "$missing_prereq"
391 then
392 missing_prereq=$prerequisite
393 else
394 missing_prereq="$prerequisite,$missing_prereq"
395 fi
396 esac
397 done
398
399 test $total_prereq = $ok_prereq
400 }
401
402 test_declared_prereq () {
403 case ",$test_prereq," in
404 *,$1,*)
405 return 0
406 ;;
407 esac
408 return 1
409 }
410
411 # You are not expected to call test_ok_ and test_failure_ directly, use
412 # the text_expect_* functions instead.
413
414 test_ok_ () {
415 test_success=$(($test_success + 1))
416 say_color "" "ok $test_count - $@"
417 }
418
419 test_failure_ () {
420 test_failure=$(($test_failure + 1))
421 say_color error "not ok - $test_count $1"
422 shift
423 echo "$@" | sed -e 's/^/# /'
424 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
425 }
426
427 test_known_broken_ok_ () {
428 test_fixed=$(($test_fixed+1))
429 say_color "" "ok $test_count - $@ # TODO known breakage"
430 }
431
432 test_known_broken_failure_ () {
433 test_broken=$(($test_broken+1))
434 say_color skip "not ok $test_count - $@ # TODO known breakage"
435 }
436
437 test_debug () {
438 test "$debug" = "" || eval "$1"
439 }
440
441 test_run_ () {
442 test_cleanup=:
443 eval >&3 2>&4 "$1"
444 eval_ret=$?
445 eval >&3 2>&4 "$test_cleanup"
446 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
447 echo ""
448 fi
449 return 0
450 }
451
452 test_skip () {
453 test_count=$(($test_count+1))
454 to_skip=
455 for skp in $GIT_SKIP_TESTS
456 do
457 case $this_test.$test_count in
458 $skp)
459 to_skip=t
460 break
461 esac
462 done
463 if test -z "$to_skip" && test -n "$test_prereq" &&
464 ! test_have_prereq "$test_prereq"
465 then
466 to_skip=t
467 fi
468 case "$to_skip" in
469 t)
470 of_prereq=
471 if test "$missing_prereq" != "$test_prereq"
472 then
473 of_prereq=" of $test_prereq"
474 fi
475
476 say_color skip >&3 "skipping test: $@"
477 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
478 : true
479 ;;
480 *)
481 false
482 ;;
483 esac
484 }
485
486 test_expect_failure () {
487 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
488 test "$#" = 2 ||
489 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
490 export test_prereq
491 if ! test_skip "$@"
492 then
493 say >&3 "checking known breakage: $2"
494 test_run_ "$2"
495 if [ "$?" = 0 -a "$eval_ret" = 0 ]
496 then
497 test_known_broken_ok_ "$1"
498 else
499 test_known_broken_failure_ "$1"
500 fi
501 fi
502 echo >&3 ""
503 }
504
505 test_expect_success () {
506 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
507 test "$#" = 2 ||
508 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
509 export test_prereq
510 if ! test_skip "$@"
511 then
512 say >&3 "expecting success: $2"
513 test_run_ "$2"
514 if [ "$?" = 0 -a "$eval_ret" = 0 ]
515 then
516 test_ok_ "$1"
517 else
518 test_failure_ "$@"
519 fi
520 fi
521 echo >&3 ""
522 }
523
524 test_expect_code () {
525 test "$#" = 4 && { prereq=$1; shift; } || prereq=
526 test "$#" = 3 ||
527 error "bug in the test script: not 3 or 4 parameters to test-expect-code"
528 if ! test_skip "$@"
529 then
530 say >&3 "expecting exit code $1: $3"
531 test_run_ "$3"
532 if [ "$?" = 0 -a "$eval_ret" = "$1" ]
533 then
534 test_ok_ "$2"
535 else
536 test_failure_ "$@"
537 fi
538 fi
539 echo >&3 ""
540 }
541
542 # test_external runs external test scripts that provide continuous
543 # test output about their progress, and succeeds/fails on
544 # zero/non-zero exit code. It outputs the test output on stdout even
545 # in non-verbose mode, and announces the external script with "# run
546 # <n>: ..." before running it. When providing relative paths, keep in
547 # mind that all scripts run in "trash directory".
548 # Usage: test_external description command arguments...
549 # Example: test_external 'Perl API' perl ../path/to/test.pl
550 test_external () {
551 test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
552 test "$#" = 3 ||
553 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
554 descr="$1"
555 shift
556 export test_prereq
557 if ! test_skip "$descr" "$@"
558 then
559 # Announce the script to reduce confusion about the
560 # test output that follows.
561 say_color "" "# run $test_count: $descr ($*)"
562 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
563 # to be able to use them in script
564 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
565 # Run command; redirect its stderr to &4 as in
566 # test_run_, but keep its stdout on our stdout even in
567 # non-verbose mode.
568 "$@" 2>&4
569 if [ "$?" = 0 ]
570 then
571 if test $test_external_has_tap -eq 0; then
572 test_ok_ "$descr"
573 else
574 say_color "" "# test_external test $descr was ok"
575 test_success=$(($test_success + 1))
576 fi
577 else
578 if test $test_external_has_tap -eq 0; then
579 test_failure_ "$descr" "$@"
580 else
581 say_color error "# test_external test $descr failed: $@"
582 test_failure=$(($test_failure + 1))
583 fi
584 fi
585 fi
586 }
587
588 # Like test_external, but in addition tests that the command generated
589 # no output on stderr.
590 test_external_without_stderr () {
591 # The temporary file has no (and must have no) security
592 # implications.
593 tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
594 stderr="$tmp/git-external-stderr.$$.tmp"
595 test_external "$@" 4> "$stderr"
596 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
597 descr="no stderr: $1"
598 shift
599 say >&3 "# expecting no stderr from previous command"
600 if [ ! -s "$stderr" ]; then
601 rm "$stderr"
602
603 if test $test_external_has_tap -eq 0; then
604 test_ok_ "$descr"
605 else
606 say_color "" "# test_external_without_stderr test $descr was ok"
607 test_success=$(($test_success + 1))
608 fi
609 else
610 if [ "$verbose" = t ]; then
611 output=`echo; echo "# Stderr is:"; cat "$stderr"`
612 else
613 output=
614 fi
615 # rm first in case test_failure exits.
616 rm "$stderr"
617 if test $test_external_has_tap -eq 0; then
618 test_failure_ "$descr" "$@" "$output"
619 else
620 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
621 test_failure=$(($test_failure + 1))
622 fi
623 fi
624 }
625
626 # debugging-friendly alternatives to "test [-f|-d|-e]"
627 # The commands test the existence or non-existence of $1. $2 can be
628 # given to provide a more precise diagnosis.
629 test_path_is_file () {
630 if ! [ -f "$1" ]
631 then
632 echo "File $1 doesn't exist. $*"
633 false
634 fi
635 }
636
637 test_path_is_dir () {
638 if ! [ -d "$1" ]
639 then
640 echo "Directory $1 doesn't exist. $*"
641 false
642 fi
643 }
644
645 test_path_is_missing () {
646 if [ -e "$1" ]
647 then
648 echo "Path exists:"
649 ls -ld "$1"
650 if [ $# -ge 1 ]; then
651 echo "$*"
652 fi
653 false
654 fi
655 }
656
657
658 # This is not among top-level (test_expect_success | test_expect_failure)
659 # but is a prefix that can be used in the test script, like:
660 #
661 # test_expect_success 'complain and die' '
662 # do something &&
663 # do something else &&
664 # test_must_fail git checkout ../outerspace
665 # '
666 #
667 # Writing this as "! git checkout ../outerspace" is wrong, because
668 # the failure could be due to a segv. We want a controlled failure.
669
670 test_must_fail () {
671 "$@"
672 exit_code=$?
673 if test $exit_code = 0; then
674 echo >&2 "test_must_fail: command succeeded: $*"
675 return 1
676 elif test $exit_code -gt 129 -a $exit_code -le 192; then
677 echo >&2 "test_must_fail: died by signal: $*"
678 return 1
679 elif test $exit_code = 127; then
680 echo >&2 "test_must_fail: command not found: $*"
681 return 1
682 fi
683 return 0
684 }
685
686 # Similar to test_must_fail, but tolerates success, too. This is
687 # meant to be used in contexts like:
688 #
689 # test_expect_success 'some command works without configuration' '
690 # test_might_fail git config --unset all.configuration &&
691 # do something
692 # '
693 #
694 # Writing "git config --unset all.configuration || :" would be wrong,
695 # because we want to notice if it fails due to segv.
696
697 test_might_fail () {
698 "$@"
699 exit_code=$?
700 if test $exit_code -gt 129 -a $exit_code -le 192; then
701 echo >&2 "test_might_fail: died by signal: $*"
702 return 1
703 elif test $exit_code = 127; then
704 echo >&2 "test_might_fail: command not found: $*"
705 return 1
706 fi
707 return 0
708 }
709
710 # test_cmp is a helper function to compare actual and expected output.
711 # You can use it like:
712 #
713 # test_expect_success 'foo works' '
714 # echo expected >expected &&
715 # foo >actual &&
716 # test_cmp expected actual
717 # '
718 #
719 # This could be written as either "cmp" or "diff -u", but:
720 # - cmp's output is not nearly as easy to read as diff -u
721 # - not all diff versions understand "-u"
722
723 test_cmp() {
724 $GIT_TEST_CMP "$@"
725 }
726
727 # This function can be used to schedule some commands to be run
728 # unconditionally at the end of the test to restore sanity:
729 #
730 # test_expect_success 'test core.capslock' '
731 # git config core.capslock true &&
732 # test_when_finished "git config --unset core.capslock" &&
733 # hello world
734 # '
735 #
736 # That would be roughly equivalent to
737 #
738 # test_expect_success 'test core.capslock' '
739 # git config core.capslock true &&
740 # hello world
741 # git config --unset core.capslock
742 # '
743 #
744 # except that the greeting and config --unset must both succeed for
745 # the test to pass.
746
747 test_when_finished () {
748 test_cleanup="{ $*
749 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
750 }
751
752 # Most tests can use the created repository, but some may need to create more.
753 # Usage: test_create_repo <directory>
754 test_create_repo () {
755 test "$#" = 1 ||
756 error "bug in the test script: not 1 parameter to test-create-repo"
757 repo="$1"
758 mkdir -p "$repo"
759 (
760 cd "$repo" || error "Cannot setup test environment"
761 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
762 error "cannot run git init -- have you built things yet?"
763 mv .git/hooks .git/hooks-disabled
764 ) || exit
765 }
766
767 test_done () {
768 GIT_EXIT_OK=t
769
770 if test -z "$HARNESS_ACTIVE"; then
771 test_results_dir="$TEST_DIRECTORY/test-results"
772 mkdir -p "$test_results_dir"
773 test_results_path="$test_results_dir/${0%.sh}-$$.counts"
774
775 echo "total $test_count" >> $test_results_path
776 echo "success $test_success" >> $test_results_path
777 echo "fixed $test_fixed" >> $test_results_path
778 echo "broken $test_broken" >> $test_results_path
779 echo "failed $test_failure" >> $test_results_path
780 echo "" >> $test_results_path
781 fi
782
783 if test "$test_fixed" != 0
784 then
785 say_color pass "# fixed $test_fixed known breakage(s)"
786 fi
787 if test "$test_broken" != 0
788 then
789 say_color error "# still have $test_broken known breakage(s)"
790 msg="remaining $(($test_count-$test_broken)) test(s)"
791 else
792 msg="$test_count test(s)"
793 fi
794 case "$test_failure" in
795 0)
796 # Maybe print SKIP message
797 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
798
799 if test $test_external_has_tap -eq 0; then
800 say_color pass "# passed all $msg"
801 say "1..$test_count$skip_all"
802 fi
803
804 test -d "$remove_trash" &&
805 cd "$(dirname "$remove_trash")" &&
806 rm -rf "$(basename "$remove_trash")"
807
808 exit 0 ;;
809
810 *)
811 if test $test_external_has_tap -eq 0; then
812 say_color error "# failed $test_failure among $msg"
813 say "1..$test_count"
814 fi
815
816 exit 1 ;;
817
818 esac
819 }
820
821 # Test the binaries we have just built. The tests are kept in
822 # t/ subdirectory and are run in 'trash directory' subdirectory.
823 if test -z "$TEST_DIRECTORY"
824 then
825 # We allow tests to override this, in case they want to run tests
826 # outside of t/, e.g. for running tests on the test library
827 # itself.
828 TEST_DIRECTORY=$(pwd)
829 fi
830 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
831
832 if test -n "$valgrind"
833 then
834 make_symlink () {
835 test -h "$2" &&
836 test "$1" = "$(readlink "$2")" || {
837 # be super paranoid
838 if mkdir "$2".lock
839 then
840 rm -f "$2" &&
841 ln -s "$1" "$2" &&
842 rm -r "$2".lock
843 else
844 while test -d "$2".lock
845 do
846 say "Waiting for lock on $2."
847 sleep 1
848 done
849 fi
850 }
851 }
852
853 make_valgrind_symlink () {
854 # handle only executables
855 test -x "$1" || return
856
857 base=$(basename "$1")
858 symlink_target=$GIT_BUILD_DIR/$base
859 # do not override scripts
860 if test -x "$symlink_target" &&
861 test ! -d "$symlink_target" &&
862 test "#!" != "$(head -c 2 < "$symlink_target")"
863 then
864 symlink_target=../valgrind.sh
865 fi
866 case "$base" in
867 *.sh|*.perl)
868 symlink_target=../unprocessed-script
869 esac
870 # create the link, or replace it if it is out of date
871 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
872 }
873
874 # override all git executables in TEST_DIRECTORY/..
875 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
876 mkdir -p "$GIT_VALGRIND"/bin
877 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
878 do
879 make_valgrind_symlink $file
880 done
881 OLDIFS=$IFS
882 IFS=:
883 for path in $PATH
884 do
885 ls "$path"/git-* 2> /dev/null |
886 while read file
887 do
888 make_valgrind_symlink "$file"
889 done
890 done
891 IFS=$OLDIFS
892 PATH=$GIT_VALGRIND/bin:$PATH
893 GIT_EXEC_PATH=$GIT_VALGRIND/bin
894 export GIT_VALGRIND
895 elif test -n "$GIT_TEST_INSTALLED" ; then
896 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
897 error "Cannot run git from $GIT_TEST_INSTALLED."
898 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
899 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
900 else # normal case, use ../bin-wrappers only unless $with_dashes:
901 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
902 if ! test -x "$git_bin_dir/git" ; then
903 if test -z "$with_dashes" ; then
904 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
905 fi
906 with_dashes=t
907 fi
908 PATH="$git_bin_dir:$PATH"
909 GIT_EXEC_PATH=$GIT_BUILD_DIR
910 if test -n "$with_dashes" ; then
911 PATH="$GIT_BUILD_DIR:$PATH"
912 fi
913 fi
914 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
915 unset GIT_CONFIG
916 GIT_CONFIG_NOSYSTEM=1
917 GIT_CONFIG_NOGLOBAL=1
918 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
919
920 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
921
922 if test -z "$GIT_TEST_CMP"
923 then
924 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
925 then
926 GIT_TEST_CMP="$DIFF -c"
927 else
928 GIT_TEST_CMP="$DIFF -u"
929 fi
930 fi
931
932 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
933 export GITPERLLIB
934 test -d "$GIT_BUILD_DIR"/templates/blt || {
935 error "You haven't built things yet, have you?"
936 }
937
938 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
939 then
940 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
941 export GITPYTHONLIB
942 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
943 error "You haven't built git_remote_helpers yet, have you?"
944 }
945 fi
946
947 if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
948 echo >&2 'You need to build test-chmtime:'
949 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
950 exit 1
951 fi
952
953 # Test repository
954 test="trash directory.$(basename "$0" .sh)"
955 test -n "$root" && test="$root/$test"
956 case "$test" in
957 /*) TRASH_DIRECTORY="$test" ;;
958 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
959 esac
960 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
961 rm -fr "$test" || {
962 GIT_EXIT_OK=t
963 echo >&5 "FATAL: Cannot prepare test area"
964 exit 1
965 }
966
967 test_create_repo "$test"
968 # Use -P to resolve symlinks in our working directory so that the cwd
969 # in subprocesses like git equals our $PWD (for pathname comparisons).
970 cd -P "$test" || exit 1
971
972 HOME=$(pwd)
973 export HOME
974
975 this_test=${0##*/}
976 this_test=${this_test%%-*}
977 for skp in $GIT_SKIP_TESTS
978 do
979 case "$this_test" in
980 $skp)
981 say_color skip >&3 "skipping test $this_test altogether"
982 skip_all="skip all tests in $this_test"
983 test_done
984 esac
985 done
986
987 # Provide an implementation of the 'yes' utility
988 yes () {
989 if test $# = 0
990 then
991 y=y
992 else
993 y="$*"
994 fi
995
996 while echo "$y"
997 do
998 :
999 done
1000 }
1001
1002 # Fix some commands on Windows
1003 case $(uname -s) in
1004 *MINGW*)
1005 # Windows has its own (incompatible) sort and find
1006 sort () {
1007 /usr/bin/sort "$@"
1008 }
1009 find () {
1010 /usr/bin/find "$@"
1011 }
1012 sum () {
1013 md5sum "$@"
1014 }
1015 # git sees Windows-style pwd
1016 pwd () {
1017 builtin pwd -W
1018 }
1019 # no POSIX permissions
1020 # backslashes in pathspec are converted to '/'
1021 # exec does not inherit the PID
1022 test_set_prereq MINGW
1023 ;;
1024 *)
1025 test_set_prereq POSIXPERM
1026 test_set_prereq BSLASHPSPEC
1027 test_set_prereq EXECKEEPSPID
1028 test_set_prereq NOT_MINGW
1029 ;;
1030 esac
1031
1032 test -z "$NO_PERL" && test_set_prereq PERL
1033 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1034
1035 # test whether the filesystem supports symbolic links
1036 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1037 rm -f y
1038
1039 # When the tests are run as root, permission tests will report that
1040 # things are writable when they shouldn't be.
1041 test -w / || test_set_prereq SANITY